<template>
  <div class="wait-task-analysis">
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList" :height="tableHeight">
        <el-table-column
          type="index"
          label="序号"
          width="50"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="semesterName"
          label="学期"
          min-width="160"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          prop="examName"
          label="考试"
          min-width="160"
          show-overflow-tooltip
        >
        </el-table-column>
        <el-table-column
          prop="courseCode"
          label="课程(代码)"
          min-width="260"
          show-overflow-tooltip
        >
          <span slot-scope="scope">
            {{ scope.row.courseName }}（{{ scope.row.courseCode }}）
          </span>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="100"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button class="btn-primary" type="text" @click="toDo(scope.row)"
              >立即处理</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div v-if="!isOnePage" class="part-page">
        <el-pagination
          background
          layout="total, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyBaseConfig -->
    <modify-base-config
      ref="ModifyBaseConfig"
      :instance="curTask"
      @closed="updateList"
    ></modify-base-config>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { analysisWaitTaskListPage } from "../api";
import ModifyBaseConfig from "../../analysis/components/ModifyBaseConfig.vue";

export default {
  name: "wait-task-analysis",
  components: { ModifyBaseConfig },
  data() {
    return {
      current: 1,
      size: 2,
      total: 0,
      dataList: [],
      curTask: {},
    };
  },
  computed: {
    ...mapState("exam", ["waitTask"]),
    isOnePage() {
      return this.waitTask.analysis <= 3;
    },
    pageSize() {
      return this.isOnePage ? 3 : 2;
    },
    tableHeight() {
      return this.isOnePage ? 174 : 127;
    },
  },
  mounted() {
    this.getList();
  },
  methods: {
    ...mapActions("exam", ["updateWaitTaskCount"]),
    async updateList() {
      await this.updateWaitTaskCount();
      await this.getList();
    },
    async getList() {
      const datas = {
        pageNumber: this.current,
        pageSize: this.pageSize,
      };
      const data = await analysisWaitTaskListPage(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toDo(task) {
      this.curTask = { ...task };
      this.$refs.ModifyBaseConfig.open();
    },
  },
};
</script>
